PROC WaitHandler(Trigger_a,Event_y,cycle_n)
     ; Trigger_a = trigger name or "EVENT"
     ; Event_y = Dynamic Array containing event
     ; Cycle_n = constant for all calls caused by the same event

   SWITCH
      CASE Trigger_a = "EVENT" AND Event_Y["KeyCode"] = ASC("F2"):
         RETURN 2                 ; Terminate WAIT
      CASE Trigger_a = "EVENT" AND Event_Y["KeyCode"] = ASC("F7"):
         FORMKEY
         RETURN 1                 ; Ignore Event
      CASE Trigger_a = "POSTRECORD" AND ISBLANK([NAME]):
         BEEP
         MESSAGE "Please Fill in the Name Field"
         MOVETO [NAME]
         RETURN 1                 ; Ignore Event
   ENDSWITCH
   RETURN 0                       ; Process event normally

ENDPROC

VIEW "TABLE"
WAIT TABLE PROC "WaitHandler"
   KEY "F7","F2"
   TRIGGER "POSTRECORD"
ENDWAIT


PROC WaitHandler2(Trigger_a,Event_y,Cycle_n)

   SETCANVAS W
   IF Trigger_a = "EVENT"
     THEN ?? "EVENT: ",Event_Y["TYPE"]
          IF Event_Y["TYPE"] = "KEY" 
             AND Event_Y["KeyCode"] = ASC("F2")
            THEN RETURN 2       ; DONE!
          ENDIF
     ELSE ?? "TRIGGER: ",Trigger_a
   ENDIF
   CLEAR EOL ? "" CLEAR EOL     ; Clear Next Line
   RETURN 0                     ; Process event normally

ENDPROC

WINDOW CREATE TO W  ; Sets up a window to write events on
ECHO NORMAL         ; Keeps speed up!

COEDIT "TABLE"
WAIT WORKSPACE PROC "WaitHandler2"
   KEY "ALL" MOUSE "ALL" MESSAGE "ALL" TRIGGER "ALL"
ENDWAIT

ECHO OFF
RESET
WINDOW SELECT W
WINDOW CLOSE 

